/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020                                    ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_ERRORHANDLING_ERROR_H_
#define DRN_ERRORHANDLING_ERROR_H_

#include <stdexcept>
#include <string>

#include "error-handling_export.h"


namespace drn
{
namespace error_handling
{

/**
 * @brief Represents a generalised error while code is being executed.
 */
class DRN_ERROR_HANDLING_EXPORT Error : public std::runtime_error
{
	std::string message_;

public:
	explicit Error(const std::string& message, const std::exception& root = {});
	/**
	 * @brief The primary error message.
	 */
	const std::string& message() const;
};

}}

#endif
