/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020                                    ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_NETWORK_QTACCESSMANAGER_HPP_
#define DRN_NETWORK_QTACCESSMANAGER_HPP_

#include <QNetworkAccessManager>

#include "AccessManager.hpp"
#include "network_export.h"


class QNetworkReply;
class QNetworkRequest;

namespace drn
{
namespace network
{

/**
 * @brief Provides network access via the Qt manager.
 */
struct DRN_NETWORK_EXPORT QtAccessManager : QNetworkAccessManager, AccessManager
{
	using QNetworkAccessManager::QNetworkAccessManager;

	QNetworkReply* get(const QNetworkRequest& request) override;
};

}}

#endif

